#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
} Leader;

//   .
typedef struct T 
{ 
  Lref Id; 
  Tref Next; 
} Trailer;

//   .
typedef Lref TipElement;
typedef struct Zveno *svqz;
typedef struct Zveno 
{ 
  TipElement Element; //   .
  svqz Sled; 
} St;

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    void SearchGraph (int, Lref *);
    void W_S (svqz *, TipElement);
    void YDALENIE (svqz *, TipElement *);
    Lref Search (int);
    void DeleteGraph (int, int);
  public:
    Spisok() {//   .
              Head = Tail =  new (Leader); }
    void MakeGraph ();
    void PrintGraph ();
    void Euler ();
};

void main ()
{
  Spisok A;
  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //  .
  A.Euler(); 
  A.PrintGraph (); cout<<endl;
} 

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (Trailer); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<<"("<<(*p).Key; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::W_S (svqz *stk, TipElement el)
//  el   stk.
{
  svqz q=new (St);
  (*q).Element = el; (*q).Sled = *stk; *stk = q;
}

void Spisok::YDALENIE (svqz *stk, TipElement *klad)
//   ,   *stk. 
//     - 
//   klad.
{
  svqz q;

  if (*stk==NULL) cout<<"    !\n";
  else
   { *klad = (**stk).Element; q = *stk; *stk = (**stk).Sled; delete q; }
}

void Spisok::DeleteGraph (int x,int y)
//   *Head   
//,    
//   (x,y).
{
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .

  // ,      (x,y)? 
  p = Search (x);q = Search (y);
  if ((p!=NULL) && (q!=NULL))
  { //    . 
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL) && (!Res)) 
     if ((*r).Id==q) Res = TRUE; 
     else r = (*r).Next; 
     if (Res) //  ,   .
       if (r==(*p).Trail) 
        { (*p).Trail = (*(*p).Trail).Next; delete r; (*q).Count--; } 
       else { 
           t = (*p).Trail; 
          while ((*t).Next!=r) t = (*t).Next; 
          (*t).Next = (*(*t).Next).Next; delete r; (*q).Count--; }
  }
}

Lref Spisok::Search (int w)
//       
// w.   ,    
//NULL.
{
  Lref h;

  h = Head;
  (*Tail).Key = w; // " ".
  while ((*h).Key!=w) h = (*h).Next;
    if (h==Tail) //        w.
      h = NULL;
  return h;
}

void Spisok::Euler ()
//        
//,     .   
// Head.
{
  Lref v,u; // .
  svqz q;   // .

  svqz Stack =NULL, CE = NULL;
  W_S (&Stack,Head);
  while (Stack!=NULL)
  {
    //     Stack...
    v = Stack->Element;
	 if  (v->Trail!=NULL)
    {
      u = v->Trail->Id;
		W_S (&Stack,u);
      DeleteGraph (v->Key,u->Key);
      DeleteGraph (u->Key,v->Key);
    }
    else
    {
      YDALENIE (&Stack,&v);
      W_S (&CE,v);
    }
  }
  //  CE   .
  q = CE;
  while  (q!=NULL)
  {  cout << q->Element->Key << ' '; q = q->Sled; }
}
